@import url('https://fonts.googleapis.com/css2?family=Hind:wght@500;700&display=swap');
@import '../../assets/colors.scss';

$arrow-width: 3px;
$arrow-height: 5px;
$error-border-width: 1px;

.uui {
  position: relative;
  display: inline-block;
  --width: 180px;
  --arrow-offset: calc(var(--width) / 2 - $arrow-width - $error-border-width);

  &--default {
    --button-background: #{$Green};
    --button-background-hover: #4e5042;
    --popup-background: #{$Green};
  }

  &--dark {
    --button-background: #{$LightBlack};
    --button-background-hover: #484848;
    --popup-background: #{$LightBlack};
  }

  &--deprecated {
    --popup-background: #{$DarkYellow};
  }

  &--compact {
    --width: 80px;
  }

  &--slim &__button {
    height: 40px;
  }

  &__button {
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 0 15px;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    background: var(--button-background);
    color: $White;
    font-family: 'Hind', sans-serif;
    transition: background 0.3s;
    width: var(--width);

    &:focus {
      outline: none;
    }

    &:hover {
      background: var(--button-background-hover);
      transition: background 0.3s;
    }

    &-status {
      height: 10px;
      width: 10px;
      border-radius: 50%;
      transition: background 0.5s;

      &--green {
        background: $LightGreen;
        transform: scale(1);
        animation: handy-status-pulse 3s infinite;
      }

      &--blue {
        background: $Blue;
      }

      &--orange {
        background: $Orange;
      }

      &--red {
        background: $Red;
      }
    }

    &-icon {
      height: 50px;
      position: relative;
      top: 3px;
    }

    &-text {
      flex-grow: 1;
    }
  }

  &__popup {
    position: absolute;
    z-index: 9999;
    visibility: visible;
    opacity: 1;
    transition: visibility 0.3s, opacity 0.3s;

    &--hidden {
      visibility: hidden;
      opacity: 0;
      transition: visibility 0.3s, opacity 0.3s;
    }

    &-arrow {
      position: relative;
      border-width: 10px;
      border-style: solid;
      border-color: transparent transparent var(--popup-background);
    }

    &-content {
      border-radius: 5px;
      overflow: hidden;
      position: absolute;
      box-shadow: 0 13px 27px -5px rgba(50, 50, 93, 0.25),
        0 8px 16px -8px rgba(0, 0, 0, 0.3);
      background: var(--popup-background);

      iframe {
        border: none;
        width: 100%;
        height: 100%;
      }
    }

    &-offline {
      height: 100%;
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      color: $White;
      font-family: 'Hind', sans-serif;
      padding: 0 15px;
      text-align: center;

      svg {
        height: 100px;
        margin-bottom: 16px;
        fill: #9aa0a6;
      }

      p {
        margin: 0;
      }

      p + p {
        margin-top: 16px;
      }
    }
  }

  &__error {
    position: absolute;
    background: var(--button-background);
    border: $error-border-width solid #f27474;
    border-radius: 5px;
    top: calc(100% + $arrow-height);
    padding: 8px 18px 8px 9px;
    font-size: 14px;
    line-height: 1.6;
    color: $White;
    display: flex;
    align-items: center;
    white-space: nowrap;
    visibility: visible;
    opacity: 1;
    transition: visibility 0.3s, opacity 0.3s;

    &--hidden {
      visibility: hidden;
      opacity: 0;
      transition: visibility 0.3s, opacity 0.3s;
    }

    &--left {
      left: 0;

      &::before {
        left: var(--arrow-offset);
      }
    }

    &--center {
      left: 50%;
      transform: translateX(-50%);

      &::before {
        left: 50%;
        transform: translateX(-50%);
      }
    }

    &--right {
      right: 0;

      &::before {
        right: var(--arrow-offset);
      }
    }

    &::before {
      content: '';
      border-width: $arrow-height $arrow-width;
      border-style: solid;
      border-color: transparent transparent var(--button-background);
      position: absolute;
      bottom: 100%;
    }

    &-icon {
      flex: 0 0 14px;
      width: 14px;
      margin-right: 8px;
    }
  }
}

@keyframes handy-status-pulse {
  0% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 rgba(114, 201, 62, 0.7);
  }

  70% {
    transform: scale(1);
    box-shadow: 0 0 0 10px transparent;
  }

  100% {
    transform: scale(0.95);
    box-shadow: 0 0 0 0 transparent;
  }
}
